exports.model=Model={Game:{},Board:{},Move:{}},function(){var t;Model.Game.cbConstants={MASK:65535,FLAG_MOVE:65536,FLAG_CAPTURE:131072,FLAG_STOP:262144,FLAG_SCREEN_CAPTURE:524288,FLAG_CAPTURE_KING:1048576,FLAG_CAPTURE_NO_KING:2097152};var e="undefined"!=typeof Int32Array;Model.Game.cbUseTypedArrays=e,Model.Game.cbTypedArray=function(t){if(e){var r=new Int32Array(t.length);return r.set(t),r}for(var i=[],a=t.length,n=0;n<a;n++)i.push(t[n]);return i},Model.Game.cbShortRangeGraph=function(t,e,r,i){var a=this;void 0===i&&(i=196608);for(var n={},s=0;s<t.boardSize;s++)n[s]=[],(!r||s in r)&&e.forEach(function(e){var o=t.Graph(s,e);null!=o&&(!r||o in r)&&n[s].push(a.cbTypedArray([o|i]))});return n},

Model.Game.cbLongRangeGraph=function(t,e,r,i,a){
 var n=this;void 0!==i&&null!=i||(i=196608),a||(a=1/0);
 var j=i&15, k=i>>4&15; i&=~255;
 for(var s={},o=0;o<t.boardSize;o++)
  s[o]=[],
  (!r||o in r)&&e.forEach(function(e){
   for(var h=[],c=t.Graph(o,e),p=0;null!=c&&(!r||c in r)&&(p<j||h.push(c|i^(p<k?0x70000:0)),++p!=a);)
    c=t.Graph(c,e);
   h.length>0&&s[o].push(n.cbTypedArray(h))
  });
 return s
},

Model.Game.cbNullGraph=function(t){for(var e={},r=0;r<t.boardSize;r++)e[r]=[];return e},

Model.Game.cbAuthorGraph=function(t){for(var e={},r=0;r<t.boardSize;r++){e[r]=[];for(var i=0;i<t.boardSize;i++)e[r].push([2293760|i])}return e},Model.Game.cbMergeGraphs=function(t){for(var e=[],r=0;r<t.boardSize;r++){e[r]=[];for(var i=1;i<arguments.length;i++)e[r]=e[r].concat(arguments[i][r])}return e},

Model.Game.cbGetThreatGraph=function(){function t(e,r){for(var i in s){var a=s[i];if(!(a.p.length<r.length+1)){for(var n=!0,o=0;o<r.length;o++)if(r[o]!=a.p[o]){n=!1;break}if(n){var h=a.p[r.length],c=e[h];void 0===c&&(c={e:{}},e[h]=c),a.p.length==r.length+1&&(c.t=a.t,c.ts=a.ts,c.tk=a.tk,delete s[i]),r.push(h),t(c.e,r),r.pop()}}}}var e=this;this.cbUseScreenCapture=!1,this.cbUseCaptureKing=!1,this.cbUseCaptureNoKing=!1;for(var r={1:[],"-1":[]},i=[],a=0;a<this.g.boardSize;a++)this.g.pTypes.forEach(function(t,r){t.graph[a].forEach(function(t){for(var n=[],s=0;s<t.length;s++){var o=t[s];1048576&o?(e.cbUseCaptureKing=!0,n.unshift({d:65535&o,a:a,tk:r})):2097152&o?(e.cbUseCaptureNoKing=!0,n.unshift({d:65535&o,a:a,tnk:r})):131072&o?n.unshift({d:65535&o,a:a,t:r}):262144&o?n.unshift({d:65535&o,a:a}):524288&o&&(e.cbUseScreenCapture=!0,n.unshift({d:65535&o,a:a,ts:r}))}n.length>0&&i.push(n)})});var n={};i.forEach(function(t){t.forEach(function(e,r){var i=n[e.d];void 0===i&&(i={},n[e.d]=i);for(var a=[],s=r+1;s<t.length;s++)a.push(t[s].d);a.push(e.a);var o=a.join(","),h=i[o];void 0===h&&(h={p:a,t:{},ts:{},tk:{}},i[o]=h),void 0!==e.t?h.t[e.t]=!0:void 0!==e.tk?h.tk[e.tk]=!0:void 0!==e.ts&&(h.ts[e.ts]=!0)})});for(var a=0;a<e.g.boardSize;a++){var s=n[a],o={};t(o,[]),r[1][a]=o,r[-1][a]=o}return r},Model.Game.InitGame=function(){var e=this;this.cbVar=t=this.cbDefine(),this.g.boardSize=this.cbVar.geometry.boardSize,this.g.pTypes=this.cbGetPieceTypes(),this.g.threatGraph=this.cbGetThreatGraph(),this.g.distGraph=this.cbVar.geometry.GetDistances(),this.cbPiecesCount=0,this.g.castleablePiecesCount={1:0,"-1":0};for(var r in t.pieceTypes){var i=t.pieceTypes[r];if(i.castle){(i.initial||[]).forEach(function(t){e.g.castleablePiecesCount[t.s]++})}i.initial&&(this.cbPiecesCount+=i.initial.length)}for(var a=[],r=0;r<this.cbPiecesCount;r++)a.push(r);var n=Object.keys(t.pieceTypes);this.zobrist=new JocGame.Zobrist({board:{type:"array",size:this.cbVar.geometry.boardSize,values:a},who:{values:["1","-1"]},type:{type:"array",size:this.cbPiecesCount,values:n}})},

Model.Game.cbGetPieceTypes=function(){for(var t=[],e={},r=0;r<this.cbVar.geometry.boardSize;r++)e[r]=[];for(var i in this.cbVar.pieceTypes){var a=this.cbVar.pieceTypes[i];t[i]={graph:a.graph||e,abbrev:a.abbrev||"",value:a.isKing?100:a.value||1,isKing:!!a.isKing,castle:!!a.castle,epTarget:!!a.epTarget,epCatch:!!a.epCatch,rank:a.rank||0,area:a.area||0}}return t};

var demons, jumpers, generals;
Model.Board.Init=function(t){this.zSign=0},
Model.Board.InitialPosition=function(r){
 demons=[], jumpers=[], generals={"-1":[], "1":[]};
var i=this;this.board=e?new Int16Array(r.g.boardSize):[];for(var a=0;a<r.g.boardSize;a++)this.board[a]=-1;if(this.kings={},this.pieces=[],this.ending={1:!1,"-1":!1},this.lastMove=null,r.cbVar.castle&&(this.castled={1:!1,"-1":!1}),this.zSign=r.zobrist.update(0,"who",-1),this.noCaptCount=0,this.mWho=1,r.mInitial)this.mWho=r.mInitial.turn||1,r.mInitial.pieces.forEach(function(t){var e={};for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);i.pieces.push(e)}),r.mInitial.lastMove&&(this.lastMove={f:r.mInitial.lastMove.f,t:r.mInitial.lastMove.t}),void 0!==r.mInitial.noCaptCount&&(this.noCaptCount=r.mInitial.noCaptCount),r.cbVar.castle&&r.mInitial.castle&&(this.castled={1:{k:!!r.mInitial.castle[1]&&!!r.mInitial.castle[1].k,q:!!r.mInitial.castle[1]&&!!r.mInitial.castle[1].q},"-1":{k:!!r.mInitial.castle[-1]&&!!r.mInitial.castle[-1].k,q:!!r.mInitial.castle[-1]&&!!r.mInitial.castle[-1].q}});else for(var n in r.cbVar.pieceTypes)for(var s=r.cbVar.pieceTypes[n],o=s.initial||[],h=0;h<o.length;h++){var c=o[h],p={s:c.s,t:parseInt(n),p:c.p,m:!1};this.pieces.push(p)}if(this.pieces.sort(function(t,e){if(t.s!=e.s)return e.s-t.s;var i=r.cbVar.pieceTypes[t.t].value||100,a=r.cbVar.pieceTypes[e.t].value||100;return i!=a?i-a:t.p-e.p}),
this.pieces.forEach(function(t,e){
 if(t.t==49||t.t==69||t.t==18)demons.push(e);
 if(t.t==19||t.t==20)jumpers[e]=t.t-15;    // 4 (BG) or 5 (RG)
 if(t.t==47||t.t==48)jumpers[e]=t.t-40;    // 7 (VG) or 8 (GG)
 if(t.t>33&&t.t<38)jumpers[e]=t.t-32 >> 1; // 1 (HF) or 2 (SE)
 if(t.t==48) generals[t.s][0] = e;
 if(t.t==47) generals[t.s][1] = e;
 if(t.t==20) generals[t.s][2 + (generals[t.s][2] !== undefined)] = e;
 t.i=e,i.board[t.p]=e,r.g.pTypes[t.t].isKing&&(i.kings[t.s]=t.p),
 i.zSign=r.zobrist.update(i.zSign,"board",e,t.p),
 i.zSign=r.zobrist.update(i.zSign,"type",t.t,e)
}),
r.mInitial&&r.mInitial.enPassant){var a=t.geometry.PosByName(r.mInitial.enPassant);if(a>=0){var l,u=t.geometry.C(a),v=t.geometry.R(a);l=1==r.mInitial.turn?t.geometry.POS(u,v-1):t.geometry.POS(u,v+1),this.epTarget={p:a,i:this.board[l]}}}},Model.Board.CopyFrom=function(t){if(e)this.board=new Int16Array(t.board.length),this.board.set(t.board);else{this.board=[];for(var r=t.board,i=r.length,a=0;a<i;a++)this.board.push(r[a])}this.pieces=[];for(var n=t.pieces.length,a=0;a<n;a++){var s=t.pieces[a];this.pieces.push({s:s.s,p:s.p,t:s.t,i:s.i,m:s.m})}this.kings={1:t.kings[1],"-1":t.kings[-1]},this.check=t.check,t.lastMove?this.lastMove={f:t.lastMove.f,t:t.lastMove.t,c:t.lastMove.c}:this.lastMove=null,this.ending={1:t.ending[1],"-1":t.ending[-1]},void 0!==t.castled&&(this.castled={1:t.castled[1],"-1":t.castled[-1]}),this.noCaptCount=t.noCaptCount,t.epTarget?this.epTarget={p:t.epTarget.p,i:t.epTarget.i}:this.epTarget=null,this.mWho=t.mWho,this.zSign=t.zSign},Model.Board.cbApplyCastle=function(t,e,r){var i=t.cbVar.castle[e.f+"/"+e.cg],a=i.r[i.r.length-1],n=this.pieces[this.board[e.cg]],s=i.k[i.k.length-1],o=this.pieces[this.board[e.f]];return r&&(this.zSign=t.zobrist.update(this.zSign,"board",n.i,e.cg),this.zSign=t.zobrist.update(this.zSign,"board",n.i,a),this.zSign=t.zobrist.update(this.zSign,"board",o.i,e.f),this.zSign=t.zobrist.update(this.zSign,"board",o.i,s)),n.p=a,n.m=!0,this.board[e.cg]=-1,o.p=s,o.m=!0,this.board[e.f]=-1,this.board[a]=n.i,this.board[s]=o.i,this.castled[n.s]=!0,this.kings[o.s]=s,[{i:n.i,f:a,t:-1},{i:o.i,f:s,t:e.f,kp:e.f,who:o.s,m:!1},{i:n.i,f:-1,t:e.cg,m:!1,cg:!1}]}

var tunnel;
Model.Board.cbQuickApply=function(t,e){
 if(void 0!==e.cg)return this.cbApplyCastle(t,e,!1);
 var r=[],i=this.board[e.f],a=this.pieces[i];
 tunnel = this.inCheck;
 if(null!=e.c){
  if(jumpers[e.c] && checkBoard[e.t]) tunnel = checkBoard[e.t];
  r.unshift({i:e.c,f:-1,t:this.pieces[e.c].p});
  var n=this.pieces[e.c];
  this.board[n.p]=-1,n.p=-1
 }
 var s=this.kings[a.s];
 if(jumpers[i] && (jumpers[i] > 2 || a.t > 50)) {
   if(checkBoard[e.f]) tunnel |= checkBoard[e.f];
   if(checkBoard[e.t]) tunnel |= checkBoard[e.t];
 }
 if(e.via && jumpers[e.kill]) {
   if(checkBoard[e.via]) tunnel |= checkBoard[e.via];
 }
 if(t.g.pTypes[a.t].isKing){
  tunnel|=1;
  this.kings[a.s]=e.t
 }
//if(tunnel)alert(tunnel+' ('+e.f+','+e.t+')');
 r.unshift({i:i,f:e.t,t:e.f,kp:s,who:a.s,ty:a.t}),
 a.p=e.t,void 0!==e.pr&&(a.t=e.pr),this.board[e.f]=-1,this.board[e.t]=i;
 return r
},
Model.Board.cbQuickUnapply=function(t,e){for(var r=0;r<e.length;r++){var i=e[r],a=this.pieces[i.i];i.f>=0&&(a.p=-1,this.board[i.f]=-1),i.t>=0&&(a.p=i.t,this.board[i.t]=i.i),void 0!==i.m&&(a.m=i.m),void 0!==i.kp&&(this.kings[i.who]=i.kp),void 0!=i.ty&&(a.t=i.ty),void 0!=i.cg&&(this.castled[a.s]=i.cg)}},

Model.Board.ApplyMove=function(t,e){
console.log(e);
 var r=this.pieces[this.board[e.f]];
 if(void 0!==e.cg)this.cbApplyCastle(t,e,!0);
 else{
  if(this.zSign=t.zobrist.update(this.zSign,"board",r.i,e.f),
   this.board[r.p]=-1,
   void 0!==e.pr&&(this.zSign=t.zobrist.update(this.zSign,"type",r.t,r.i),
   r.t=e.pr,this.zSign=t.zobrist.update(this.zSign,"type",r.t,r.i)),
   null!=e.c){
   var i=this.pieces[e.c];
   this.zSign=t.zobrist.update(this.zSign,"board",i.i,i.p),
   this.board[i.p]=-1,i.p=-1,i.m=!0,this.noCaptCount=0
  }else this.noCaptCount++;
  r.p=e.t,r.m=!0,this.board[e.t]=r.i,
  this.zSign=t.zobrist.update(this.zSign,"board",r.i,e.t),
  t.g.pTypes[r.t].isKing&&(this.kings[r.s]=e.t)
 }
 this.check=e.ck,
 this.lastMove={f:e.f,t:e.t,c:e.c},
 void 0!==e.ko&&(this.ending[r.s]=e.ko),
 void 0!==e.ept?this.epTarget={p:e.ept,i:r.i}:this.epTarget=null,
 this.zSign=t.zobrist.update(this.zSign,"who",-this.mWho),
 this.zSign=t.zobrist.update(this.zSign,"who",this.mWho)
},

Model.Board.Evaluate=function(r){
function i(e){var r=1/0;for(var i in t.geometry.corners)r=Math.min(r,h.distGraph[n.kings[e]][i]);return r-Math.sqrt(h.boardSize)}
var a="debug"==arguments[3],n=this;this.mEvaluation=0;var s,o=this.mWho,h=r.g;
if(e)s={1:{count:new Uint8Array(h.pTypes.length),byType:{}},"-1":{count:new Uint8Array(h.pTypes.length),byType:{}}};else{s={1:{count:[],byType:{}},"-1":{count:[],byType:{}}};
for(var c=0;c<h.pTypes.length;c++)s[1].count[c]=s[-1].count[c]=0}
if(r.mOptions.preventRepeat&&r.GetRepeatOccurence(this)>2)return this.mFinished=!0,void(this.mWinner=r.cbOnPerpetual?o*r.cbOnPerpetual:JocGame.DRAW);
for(
var p={1:0,"-1":0},
 l={1:h.distGraph[this.kings[-1]],"-1":h.distGraph[this.kings[1]]},
 u={1:0,"-1":0},
 v={1:0,"-1":0},
 b={1:0,"-1":0},
 f={1:0,"-1":0},
 d={1:0,"-1":0},
 g=this.pieces,
 m=g.length,
 c=0;c<m;c++){
  var G=g[c];
  if(G.p>=0){
   var y=G.s,M=h.pTypes[G.t];
   M.isKing?d[y]=G.m:p[y]+=M.value,
   M.castle&&!G.m&&f[y]++,v[y]++,u[y]+=l[y][G.p],b[y]+=t.geometry.distEdge[G.p];var C=s[y];C.count[G.t]++;var S=C.byType;void 0===S[G.t]?S[G.t]=[G]:S[G.t].push(G)}}

               if(d[o]===0 && this.kings[o]!==undefined) { // no King found, but had one before
                       this.mWinner=-o; this.mFinished=true; // opponent wins
                       return;
               }
if(this.lastMove&&null!=this.lastMove.c){
 var mover=this.board[this.lastMove.t];
 if(mover >= 0){ // could have self-immolated!
  var G=this.pieces[mover];
  p[-G.s]+=this.cbStaticExchangeEval(r,G.p,G.s,{piece:G})
}}
 var k={1:0,"-1":0},A={1:0,"-1":0},T={1:0,"-1":0};
 this.ending[1]&&(A[1]=(u[1]-Math.sqrt(h.boardSize))/v[1],t.geometry.corners&&(T[1]=i(1))),this.ending[-1]&&(A[-1]=(u[-1]-Math.sqrt(h.boardSize))/v[-1],t.geometry.corners&&(T[1]=i(-1)));
var z={pieceValue:p[1]-p[-1],pieceValueRatio:(p[1]-p[-1])/(p[1]+p[-1]+1),posValue:b[1]-b[-1],averageDistKing:u[1]/v[1]-u[-1]/v[-1],check:this.check?-o:0,endingKingFreedom:k[1]-k[-1],endingDistKing:A[1]-A[-1],distKingCorner:T[1]-T[-1]};t.castle&&(z.castle=(this.castled[1]?1:d[1]?0:f[1]/(h.castleablePiecesCount[1]+1))-(this.castled[-1]?1:d[-1]?0:f[-1]/(h.castleablePiecesCount[-1]+1))),t.evaluate&&t.evaluate.call(this,r,z,s,demons,generals);var P=r.mOptions.levelOptions;
for(var E in z){var w=z[E],R=P[E+"Factor"]||0,I=w*R;a&&console.log(E,"=",w,"*",R,"=>",I),this.mEvaluation+=I}a&&console.log("Evaluation",this.mEvaluation)}

var checkBoard;

Model.Board.cbGeneratePseudoLegalMoves=function(t,kingcapt){

 var burnMap = [];

 function e(e,a){
  if(burnMap[a.t]){ a.burn = 1; return void i.push(a) }
  var n=t.cbVar.promote;
  if(!n)return void i.push(a);
  var s=n.call(r,t,e,a);
  if(null!=s)
   if(0==s.length)i.push(a);
  else if(1==s.length)a.pr=s[0],i.push(a);
  else for(var o=0;o<s.length;o++){
   var h=s[o];
   i.push({f:a.f,t:a.t,c:a.c,pr:h,ept:a.ept,ep:a.ep,a:a.a})
 }}

 function AreaMove(s,n) {
  var graph = t.g.pTypes[50].graph[s];
  var nr = graph.length;
  map[s]=n;
  for(var j=0; j<nr; j++){
   var s1=graph[j][0]&0xFFFF;
   var v=r.board[s1];
   if(v<0 || r.pieces[v].s!=p.s) {
    if(map[s1]==undefined) {
     var move = {f:p.p,t:s1,c:(v<0?null:v),a:l.abbrev}
     if(burnMap[s1]) move.burn = 1;
     i.push(move),map[s1]=0;
    }
    if(v<0 && map[s1]<n-1) AreaMove(s1,n-1);
   }
  }
 }
//console.error('key = '+this.zSign);
 for(var dnr=0; dnr<demons.length; dnr++) {
   var demon = this.pieces[demons[dnr]];
   if(demon.p >= 0 && demon.s != this.mWho && demon.t != 18) { // present, enemy, not unpromoted WB
     var graph = t.g.pTypes[50].graph[demon.p];
     for(var burn=0; burn<graph.length; burn++) burnMap[graph[burn][0]&0xFFFF] = 1;
   }
 }

 // mark all squares from which a Queen could check either King, on an auxiliary board
 checkBoard = [];
 for(var n=-1, bit=(this.mWho>0?16:1); n<2; n+=2) {
  var king = this.kings[n];
  var graph = t.g.pTypes[48].graph[king]; // GG moves from King square
//  kingRays[n] = graph;
  for(var dir=graph.length; dir>0; dir--) {
    var ray=graph[dir-1], code = bit*dir;
    for(var range=ray.length-1; range>=0; range--) {
      var sqr = ray[range] & 0xFFFF;
      if(checkBoard[sqr]) checkBoard[sqr] |= code; else checkBoard[sqr] = code;
    }
  }
  bit^=0x11;
 }

 for(var r=this,i=[],a=t.cbVar,n=this.mWho,s=!a.castle||this.check||this.castled[n]?null:[],o=-1,h=this.pieces.length,c=0;c<h;c++){
  var p=this.pieces[c];
  if(!(p.p<0||p.s!=n)){
   var l=t.g.pTypes[p.t];
   l.isKing && (p.m?s=null:o=p),
   s && l.castle && !p.m && s.push(p);
   if(l.area){
    var map=[];
    AreaMove(p.p,3);
   }
   var u,v; u=l.graph[p.p], v=u.length;
   for(var b=0;b<v;b++)
    for(var f=u[b],d=!1,g=f.length,m=null,G=0;G<g;G++){
     var y=f[G],M=65535&y,C=this.board[M];
     if(!(C<0)||l.epCatch&&this.epTarget&&this.epTarget.p==M){
      if(!(524288&y)){
       var S;
       S=C<0?this.pieces[this.epTarget.i]:this.pieces[C];
       if(y&0x3C00000) S.s!=p.s && this.specials.push({f:p.p,t:M,c:S.i,a:l.abbrev,flag:y>>22});else
       !(S.s!=p.s&&131072&y) || 1048576&y && !t.g.pTypes[S.t].isKing ||
       2097152&y && t.g.pTypes[S.t].isKing || e(p,{f:p.p,t:M,c:S.i,a:l.abbrev});
       break
      }
       var S=this.pieces[C];
       S.s!=p.s && e(p,{f:p.p,t:M,c:S.i,a:l.abbrev});
       if(t.g.pTypes[S.t].rank>=t.g.pTypes[p.t].rank)break
      d=!0
     }else if(y&0x800000) this.specials.push({f:p.p,t:M,c:S.i,a:l.abbrev,flag:2});
     else 65536&y && 0==d && e(p,{f:p.p,t:M,c:null,a:l.abbrev,ept:null!=m&&l.epTarget?m:void 0});
     m=M
 }} }
 if(s)for(var c=0;c<s.length;c++){
  var k=s[c],A=t.cbVar.castle[o.p+"/"+k.p];
  if(A){
   for(var T=!0,b=0;b<A.r.length;b++){
    var z=A.r[b];
    if(this.board[z]>=0&&z!=o.p&&z!=k.p){T=!1;break}
   }
   if(T){
    for(var P=!0,b=0;b<A.k.length;b++){
     var z=A.k[b];
     if(this.board[z]>=0 && z!=k.p && z!=o.p || this.cbGetAttackers(t,z,n).length>0){
      P=!1;
      break
    }}
    P && i.push({f:o.p,t:A.k[A.k.length-1],c:null,cg:k.p})
 }}}
 return i
},

Model.Board.cbStaticExchangeEval=function(t,e,r,i){var a=0,n=this.cbGetSmallestAttacker(t,e,r);if(n){var s=this.mWho;this.mWho=n.s;var o=this.cbQuickApply(t,{f:n.p,t:e,c:i.piece.i}),h=t.g.pTypes[i.piece.t].value;i.piece=n,a=Math.max(0,h-this.cbStaticExchangeEval(t,e,-r,i)),this.cbQuickUnapply(t,o),this.mWho=s}return a},Model.Board.cbGetSmallestAttacker=function(t,e,r){var i=this.cbGetAttackers(t,e,r);if(0==i.length)return null;for(var a=1/0,n=null,s=i.length,o=0;o<s;o++){var h=i[o],c=t.g.pTypes[h.t].value;c<a&&(a=c,n=h)}return n},

Model.Board.cbRayScan=function(ray, who, attackers, pos) {
	var l = ray.length;
	var bar = 2;
	for(var d=0; d<l; d++) { // all squares along ray
        	var sqr = ray[d] & 0xFFFF;
        	var pi = this.board[sqr];
		if(pi >= 0 && jumpers[pi]) {         // piece is jumper (or promotes to one)
			var rank = jumpers[pi];      // its ranking: HF=1, SE=2, BG=4, RG=5, VG=7, GG=8
			var piece = this.pieces[pi]; // lookup other piece info
                        if(piece.t > 50) rank += 3;  // piece is promoted, adjust rank
			if(rank > bar) {             // rank is high enough to reach King
                        	if(piece.s != who) { // enemy
					var step = ray[0] ^ pos;
//alert('rank='+rank+' step='+(step&0xFFFF));
					if(!(step & 0xF) || !(step & 0xF0)) { // orthogonal
						if(rank == 5 || rank == 8) attackers.push(piece);
					} else { // diagonal
						if(rank != 5) attackers.push(piece);
					}
				}
				bar = rank | 1;      // raise the bar. kludge: BG->RG, but not VG->GG
				if(bar >= 8) break;  // nothing can jump over GG
			}
		}
	}
if(attackers[0]) console.log(attackers,jumpers,jumpers[18]);
},

Model.Board.cbCollectAttackers=function(t,e,r,i){
 for(var a in e){
  var n=e[a],s=this.board[a];
  if(s<0)this.cbCollectAttackers(t,n.e,r,i);
  else{
   var o=this.pieces[s];
   o.s==-t&&(n.t&&o.t in n.t||i&&n.tk&&o.t in n.tk)&&r.push(o)
}}},
Model.Board.cbCollectAttackersScreen=function(t,e,r,i,a){for(var n in e){var s=e[n],o=this.board[n];if(o<0)this.cbCollectAttackersScreen(t,s.e,r,i,a);else{var h=this.pieces[o];!a&&h.s==-t&&(s.t&&h.t in s.t||i&&s.tk&&h.t in s.tk)?r.push(h):a?a&&h.s==-t&&s.ts&&h.t in s.ts&&r.push(h):this.cbCollectAttackersScreen(t,s.e,r,i,!0)}}},
Model.Board.cbGetAttackers=function(t,e,r,i){
 var a=[];
 if(i) {
  if(tunnel & 15,1){ // used as check test, and QuickApply detected jump-check possibility
   var g = t.g.pTypes[48].graph[e];
   for(var d=g.length-1; d>=0; d--) this.cbRayScan(g[d], r, a, e);
  }
  tunnel >>= 4; // prepare to do test for other color
 }
 return t.cbUseScreenCapture
  ?this.cbCollectAttackersScreen(r,t.g.threatGraph[r][e],a,i,!1)
  :this.cbCollectAttackers(r,t.g.threatGraph[r][e],a,i),a
},
Model.Board.GenerateMoves=function(t){
 var e=this.cbGeneratePseudoLegalMoves(t),ok=0;
 this.mMoves=[];
 for(var r=!0,i=this.kings[this.mWho],a=e.length,n=0;n<a;n++){
  var s=e[n]
  if(this.kings[-this.mWho]==s.t){this.mMoves.push(s),this.mFinished=!0,this.mWinner=this.mWho;return;}else{
   if(ok)this.mMoves.push(s);else{
    var o=this.cbQuickApply(t,s);
    if(!(this.cbGetAttackers(t,this.kings[this.mWho],this.mWho,!0).length>0)){
     var h=this.cbGetAttackers(t,this.kings[-this.mWho],-this.mWho,!0).length>0;
     s.ck=h,this.mMoves.push(s),ok=1,s.f!=i&&(r=!1)
    }
    this.cbQuickUnapply(t,o)
   }
 }}
 if(0==this.mMoves.length){
  if(this.check===undefined)this.check=this.cbGetAttackers(t,this.kings[this.mWho],this.mWho,!0).length>0;
  this.mFinished=!0,this.mWinner=t.cbOnStaleMate?t.cbOnStaleMate*this.mWho:JocGame.DRAW,this.check&&(this.mWinner=-this.mWho);
 }else if(this.ending[this.mWho]){
  if(!r)for(var n=0;n<this.mMoves.length;n++)this.mMoves[n].ko=!1
 }else if(!this.ending[this.mWho]&&r&&!this.check) for(var n=0;n<this.mMoves.length;n++)this.mMoves[n].ko=!0
},
Model.Board.GetSignature=function(){return this.zSign},Model.Move.Init=function(t){for(var e in t)t.hasOwnProperty(e)&&(this[e]=t[e])},Model.Move.Equals=function(t){return this.f==t.f&&this.t==t.t&&this.pr==t.pr},Model.Move.CopyFrom=function(t){this.Init(t)},Model.Move.ToString=function(e){var r=this;switch(e=e||"natural"){case"natural":return function(){var e;if(void 0!==r.cg?e=t.castle[r.f+"/"+r.cg].n:(e=r.a||"",e+=t.geometry.PosName(r.f),null==r.c?e+="-":e+="x",e+=t.geometry.PosName(r.t)),void 0!==r.pr){var i=t.pieceTypes[r.pr];i&&i.abbrev&&i.abbrev.length>0&&!i.silentPromo&&(e+="="+i.abbrev)}return r.ck&&(e+="+"),e}();case"engine":return function(){var e=t.geometry.PosName(r.f)+t.geometry.PosName(r.t);if(void 0!=r.pr){var i=t.pieceTypes[r.pr];i&&i.abbrev&&i.abbrev.length>0&&!i.silentPromo&&(e+=i.abbrev)}return e}();default:return"??"}},Model.Board.CompactMoveString=function(e,r,i){"function"!=typeof r.ToString&&(r=e.CreateMove(r));var a=r.ToString(),n=/^([A-Z]?)([a-z])([1-9][0-9]*)([-x])([a-z])([1-9][0-9]*)(.*?)$/.exec(a);if(!n)return a;var s=n[7];if(i||(i={}),i.value||(i.value=[]),0==i.value.length){var o=this.mMoves;this.mMoves&&0!=this.mMoves.length||this.GenerateMoves(e);for(var h=0;h<this.mMoves.length;h++){var c=this.mMoves[h];"function"!=typeof c.ToString&&(c=e.CreateMove(c)),i.value.push({str:c.ToString(),move:c})}this.mMoves=o}var p=[];if(i.value.forEach(function(t){var e=/^([A-Z]?[a-z][1-9][0-9]*[-x][a-z][1-9][0-9]*)(.*?)$/.exec(t.str);e&&t.move.t==r.t&&(t.move.a||"")==n[1]&&e[2]==s&&p.push(t.move)}),1==p.length)return""==n[1]&&"x"==n[4]?n[2]+"x"+n[5]+n[6]+n[7]:n[1]+("x"==n[4]?"x":"")+n[5]+n[6]+n[7];if(t.geometry.CompactCrit)for(var l="",h=0;;h++){var u=t.geometry.CompactCrit(r.f,h);if(null==u)return a;l+=u;for(var v=[],b=0;b<p.length;b++){var f=p[b];t.geometry.CompactCrit(f.f,h)==u&&v.push(f)}if(console.assert(v.length>0),1==v.length)return n[1]+l+("x"==n[4]?"x":"")+n[5]+n[6]+n[7];p=v}return a},Model.Board.cbIntegrity=function(t){function e(t,e){t||console.error(e)}for(var r=this,i=0;i<this.board.length;i++){var a=this.board[i];if(a>=0){var n=r.pieces[a];e(void 0!==n,"no piece at pos"),e(n.p==i,"piece has different pos")}}for(var a=0;a<this.pieces.length;a++){var n=this.pieces[a];n.p>=0&&e(r.board[n.p]==a,"board index mismatch")}},Model.Board.ExportBoardState=function(t){return t.cbVar.geometry.ExportBoardState?t.cbVar.geometry.ExportBoardState(this,t.cbVar,t.mPlayedMoves.length):"not supported"},Model.Game.Import=function(e,r){var i,a=[],n={1:{},"-1":{}},s=null,o=0;if("pjn"==e){var h={status:!1,error:"parse"},c=r.split(" ");if(6!=c.length)return console.warn("FEN should have 6 parts"),h;var p=c[0].split("/"),l=t.geometry.fenHeight||t.geometry.height;if(p.length!=l)return console.warn("FEN board should have",l,"rows, got",p.length),h;var u={};for(var v in t.pieceTypes){var b=t.pieceTypes[v],f=b.fenAbbrev||b.abbrev||"X";u[f.toUpperCase()]={s:1,t:v},u[f.toLowerCase()]={s:-1,t:v}}var d=t.geometry.FenRowPos||function(e,r){return(t.geometry.height-1-e)*t.geometry.width+r};if(p.forEach(function(e,r){for(var i=0,n=0;n<e.length;n++){var s=e.substr(n,1),o=u[s];if(void 0!==o){var c=d(r,i);i++;for(var p={s:o.s,t:o.t,p:c},l=!0,v=t.pieceTypes[p.t].initial||[],b=0;b<v.length;b++){var f=v[b];f.s==p.s&&f.p==c&&(l=!1)}p.m=l,a.push(p)}else{if(isNaN(parseInt(s)))return console.warn("FEN invalid board spec",s),h;i+=parseInt(s)}}}),a.sort(function(t,e){return e.s-t.s}),"w"==c[1])i=1;else{if("b"!=c[1])return console.warn("FEN invalid turn spec",c[1]),h;i=-1}n[1].k=c[2].indexOf("K")>=0,n[1].q=c[2].indexOf("Q")>=0,n[-1].k=c[2].indexOf("k")>=0,n[-1].q=c[2].indexOf("q")>=0,s="-"==c[3]?null:c[3];var g=parseInt(c[4]);isNaN(g)||(o=g);var m={pieces:a,turn:i,castle:n,enPassant:s,noCaptCount:o};return t.importGame&&t.importGame.call(this,m,e,r),{status:!0,initial:m}}return{status:!1,error:"unsupported"}}}(),function(){Model.Game.cbBoardGeometryGrid=function(t,e){function r(e){return e%t}function i(e){return Math.floor(e/t)}function a(e,r){return r*t+e}function n(n,s){var o=r(n),h=i(n),c=o+s[0],p=h+s[1];return c<0||c>=t||p<0||p>=e?null:a(c,p)}function s(t){return String.fromCharCode("a".charCodeAt(0)+r(t))+(i(t)+1)}function o(t){var e=/^([a-z])([0-9]+)$/.exec(t);return e?a(e[1].charCodeAt(0)-"a".charCodeAt(0),parseInt(e[2])-1):-1}function h(t,e){return 0==e?String.fromCharCode("a".charCodeAt(0)+r(t)):1==e?i(t)+1:null}function c(){for(var a=[],n=0;n<t*e;n++){var s=[];a.push(s);for(var o=0;o<t*e;o++){var h=i(n),c=r(n),p=i(o),l=r(o);s.push(Math.max(Math.abs(h-p),Math.abs(c-l)))}}return a}function p(r,i,n){for(var o=[],h=e-1;h>=0;h--){for(var c="",p=0,l=0;l<t;l++){var u=r.board[a(l,h)];if(u<0)p++;else{p>0&&(c+=p,p=0);var v=r.pieces[u],b=i.pieceTypes[v.t].fenAbbrev||i.pieceTypes[v.t].abbrev||"?";v.s==-1?c+=b.toLowerCase():c+=b.toUpperCase()}}p&&(c+=p),o.push(c)}var f=o.join("/");f+=" ",1==r.mWho?f+="w":f+="b",f+=" ";var d="";return r.castled&&(r.castled[1]===!1?d+="KQ":(r.castled[1].k&&(d+="K"),r.castled[1].q&&(d+="Q")),r.castled[-1]===!1?d+="kq":(r.castled[-1].k&&(d+="k"),r.castled[-1].q&&(d+="q"))),0==d.length&&(d="-"),f+=d,f+=" ",r.epTarget?f+=s(r.epTarget.p):f+="-",f+=" ",f+=r.noCaptCount,f+=" ",f+=Math.floor(n/2)+1}return{boardSize:t*e,width:t,height:e,C:r,R:i,POS:a,Graph:n,PosName:s,PosByName:o,CompactCrit:h,GetDistances:c,distEdge:function(){for(var a=[],n=0;n<t*e;n++){var s=r(n),o=i(n);a[n]=Math.min(s,Math.abs(t-s-1),o,Math.abs(e-o-1))}return a}(),corners:function(){var r={};return r[a(0,0)]=1,r[a(0,e-1)]=1,r[a(t-1,0)]=1,r[a(t-1,e-1)]=1,r}(),ExportBoardState:p}},Model.Game.cbPawnGraph=function(t,e,r){for(var i=this,a={},n=0;n<t.boardSize;n++)if(!r||n in r){var s=[],o=t.Graph(n,[0,e]);null!=o&&(!r||o in r)&&s.push(i.cbTypedArray([o|i.cbConstants.FLAG_MOVE])),[-1,1].forEach(function(a){var o=t.Graph(n,[a,e]);null!=o&&(!r||o in r)&&s.push(i.cbTypedArray([o|i.cbConstants.FLAG_CAPTURE]))}),a[n]=s}else a[n]=[];return a},Model.Game.cbInitialPawnGraph=function(t,e,r){for(var i=this,a={},n=0;n<t.boardSize;n++)if(!r||n in r){var s=[],o=t.Graph(n,[0,e]);if(null!=o&&(!r||o in r)){var h=[o|i.cbConstants.FLAG_MOVE],c=t.Graph(o,[0,e]);null!=c&&(!r||c in r)&&h.push(c|i.cbConstants.FLAG_MOVE),s.push(i.cbTypedArray(h))}[-1,1].forEach(function(a){var o=t.Graph(n,[a,e]);null!=o&&(!r||o in r)&&s.push(i.cbTypedArray([o|i.cbConstants.FLAG_CAPTURE]))}),a[n]=s}else a[n]=[];return a},Model.Game.cbKingGraph=function(t,e){return this.cbShortRangeGraph(t,[[-1,-1],[-1,0],[-1,1],[0,-1],[0,1],[1,-1],[1,0],[1,1]],e)},Model.Game.cbKnightGraph=function(t,e){return this.cbShortRangeGraph(t,[[2,-1],[2,1],[-2,-1],[-2,1],[-1,2],[-1,-2],[1,2],[1,-2]],e)},Model.Game.cbHorseGraph=function(t){for(var e=this,r={},i=0;i<t.boardSize;i++)r[i]=[],[[1,0,2,-1],[1,0,2,1],[-1,0,-2,-1],[-1,0,-2,1],[0,1,-1,2],[0,-1,-1,-2],[0,1,1,2],[0,-1,1,-2]].forEach(function(a){var n=t.Graph(i,[a[0],a[1]]);if(null!=n){var s=t.Graph(i,[a[2],a[3]]);null!=s&&r[i].push(e.cbTypedArray([n|e.cbConstants.FLAG_STOP,s|e.cbConstants.FLAG_MOVE|e.cbConstants.FLAG_CAPTURE]))}});return r},Model.Game.cbRookGraph=function(t,e){return this.cbLongRangeGraph(t,[[0,-1],[0,1],[-1,0],[1,0]],e)},Model.Game.cbBishopGraph=function(t,e){return this.cbLongRangeGraph(t,[[1,-1],[1,1],[-1,1],[-1,-1]],e)},Model.Game.cbQueenGraph=function(t,e){return this.cbLongRangeGraph(t,[[0,-1],[0,1],[-1,0],[1,0],[1,-1],[1,1],[-1,1],[-1,-1]],e)},Model.Game.cbXQGeneralGraph=function(t,e){for(var r=this,i={},a=0;a<t.boardSize;a++)i[a]=[],[[-1,0,!1],[0,-1,!0],[0,1,!0],[1,0,!1]].forEach(function(n){var s=[],o=t.Graph(a,n);if(null!=o&&((!e||o in e)&&s.push(o|r.cbConstants.FLAG_MOVE|r.cbConstants.FLAG_CAPTURE),n[2]))for(var h=t.Graph(o,n);null!=h;)!e||h in e?s.push(h|r.cbConstants.FLAG_CAPTURE|r.cbConstants.FLAG_CAPTURE_KING):s.push(h|r.cbConstants.FLAG_STOP),h=t.Graph(h,n);s.length>0&&i[a].push(r.cbTypedArray(s))});return i},Model.Game.cbXQSoldierGraph=function(t,e){return this.cbShortRangeGraph(t,[[0,e]])},Model.Game.cbXQPromoSoldierGraph=function(t,e){return this.cbShortRangeGraph(t,[[0,e],[-1,0],[1,0]])},Model.Game.cbXQAdvisorGraph=function(t,e){return this.cbShortRangeGraph(t,[[1,1],[-1,1],[1,-1],[-1,-1]],e)},Model.Game.cbXQCannonGraph=function(t){return this.cbLongRangeGraph(t,[[0,-1],[0,1],[-1,0],[1,0]],null,this.cbConstants.FLAG_MOVE|this.cbConstants.FLAG_SCREEN_CAPTURE)},Model.Game.cbXQElephantGraph=function(t,e){for(var r=this,i={},a=0;a<t.boardSize;a++)i[a]=[],(!e||a in e)&&[[1,1,2,2],[1,-1,2,-2],[-1,1,-2,2],[-1,-1,-2,-2]].forEach(function(n){var s=t.Graph(a,[n[0],n[1]]);if(null!=s){var o=t.Graph(a,[n[2],n[3]]);null!=o&&(!e||o in e)&&i[a].push(r.cbTypedArray([s|r.cbConstants.FLAG_STOP,o|r.cbConstants.FLAG_MOVE|r.cbConstants.FLAG_CAPTURE]))}});return i},Model.Game.cbSilverGraph=function(t,e){return this.cbShortRangeGraph(t,[[0,e],[-1,-1],[-1,1],[1,-1],[1,1]])},Model.Game.cbFersGraph=function(t,e){return this.cbShortRangeGraph(t,[[-1,-1],[-1,1],[1,-1],[1,1]])},Model.Game.cbSchleichGraph=function(t,e){return this.cbShortRangeGraph(t,[[-1,0],[1,0],[0,-1],[0,1]])},Model.Game.cbAlfilGraph=function(t,e){return this.cbShortRangeGraph(t,[[-2,-2],[-2,2],[2,2],[2,-2]])}}(),

function(){

	var t=Model.Game.cbBoardGeometryGrid(16,16);

	function jumps(x, y) {
		var res = [];
		for(var j=0; j<4; j++) {
			for(var i=1; i<16; i++) res.push([i*x, i*y]);
			var h = x; x = y; y = -h;
		}
		return res;
	}

	var noncapt=65536, capt=131072;

	Model.Game.cbDefine=function(){

		return{
			geometry:t,

			pieceTypes:{

				0: {
					name: 'pawn-w',
					aspect: 'sh-pawn',
					graph: this.cbShortRangeGraph(t,[[0,1]]),
					value: 0.3,
					abbrev: '',
					fenAbbrev: 'P',
					initial: [{s:1,p:64},{s:1,p:65},{s:1,p:66},{s:1,p:67},{s:1,p:68},{s:1,p:69},{s:1,p:70},{s:1,p:71},{s:1,p:72},{s:1,p:73},{s:1,p:74},{s:1,p:75},{s:1,p:76},{s:1,p:77},{s:1,p:78},{s:1,p:79}],
				},
				
				
				1: {
					name: 'pawn-b',
					aspect: 'sh-pawn',
					graph: this.cbShortRangeGraph(t,[[0,-1]]),
					value: 0.3,
					abbrev: '',
					fenAbbrev: 'P',
					initial: [{s:-1,p:176},{s:-1,p:177},{s:-1,p:178},{s:-1,p:179},{s:-1,p:180},{s:-1,p:181},{s:-1,p:182},{s:-1,p:183},{s:-1,p:184},{s:-1,p:185},{s:-1,p:186},{s:-1,p:187},{s:-1,p:188},{s:-1,p:189},{s:-1,p:190},{s:-1,p:191}],
				},

				2: {
					name: 'lance-w',
					aspect: 'sh-lance',
					graph: this.cbLongRangeGraph(t,[[0,1]]),
					value: 1,
					abbrev: 'L',
					initial: [{s:1,p:0},{s:1,p:15}],
				},


				3: {
					name: 'lance-b',
					aspect: 'sh-lance',
					graph: this.cbLongRangeGraph(t,[[0,-1]]),
					value: 1,
					abbrev: 'L',
					initial: [{s:-1,p:240},{s:-1,p:255}],
				},

				4: {
					name: 'leopard',
					aspect: 'sh-leopard',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[-1,1],[1,1],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'FL',
					fenAbbrev: 'F',
					initial: [{s:1,p:2},{s:1,p:13},{s:-1,p:242},{s:-1,p:253}],
				},

				5: {
					name: 'side-mover',
					aspect: 'sh-sweeper',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbShortRangeGraph(t, [[0,1],[0,-1]])
						),
					value: 4,
					abbrev: 'SM',
					fenAbbrev: 'M',
					initial: [{s:1,p:48},{s:1,p:63},{s:-1,p:192},{s:-1,p:207}],
				},


				6: {
					name: 'vertical-mover',
					aspect: 'sh-climber',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1],[0,-1]]),
						this.cbShortRangeGraph(t, [[1,0],[-1,0]])
						),
					value: 4,
					abbrev: 'VM',
					fenAbbrev: 'V',
					initial: [{s:1,p:49},{s:1,p:62},{s:-1,p:193},{s:-1,p:206}],
				},

				7: {
					name: 'bishop',
					aspect: 'sh-bishop',
					graph: this.cbBishopGraph(t),
					value: 4,
					abbrev: 'B',
					initial: [{s:1,p:34},{s:1,p:45},{s:-1,p:210},{s:-1,p:221}],
				},

				8: {
					name: 'rook',
					aspect: 'sh-rook',
					graph: this.cbRookGraph(t),
					value: 5,
					abbrev: 'R',
					initial: [{s:1,p:50},{s:1,p:61},{s:-1,p:194},{s:-1,p:205}],
				},
				
				9: {
					name: 'phoenix',
					aspect: 'sh-phoenix',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[1,0],[-1,0],[-2,2],[2,2],[2,-2],[-2,-2]]),
					value: 1.5,
					abbrev: 'PH',
					fenAbbrev: 'X',
					initial: [{s:1,p:25},{s:-1,p:230}],
				},

				10: {
					name: 'kirin',
					aspect: 'sh-kirin',
					graph: this.cbShortRangeGraph(t,[[0,2],[0,-2],[2,0],[-2,0],[-1,1],[1,1],[1,-1],[-1,-1]]),
					value: 1.5,
					abbrev: 'KN',
					fenAbbrev: 'O',
					initial: [{s:1,p:22},{s:-1,p:233}],
				},

				11: {
					name: 'knight-w',
					aspect: 'sh-knight',
					graph: this.cbShortRangeGraph(t,[[-1,2],[1,2]]),
					value: 0.4,
					abbrev: 'N',
					initial: [{s:1,p:1},{s:1,p:14}],
				},

				12: {
					name: 'knight-b',
					aspect: 'sh-knight',
					graph: this.cbShortRangeGraph(t,[[-1,-2],[1,-2]]),
					value: 0.4,
					abbrev: 'N',
					initial: [{s:-1,p:241},{s:-1,p:254}],
				},

				13: {
					name: 'dog-w',
					aspect: 'sh-dog',
					graph: this.cbShortRangeGraph(t,[[0,1],[1,-1],[-1,-1]]),
					value: 0.5,
					abbrev: 'D',
					fenAbbrev: "D'",
					initial: [{s:1,p:84},{s:1,p:91}],
				},

				14: {
					name: 'dog-b',
					aspect: 'sh-dog',
					graph: this.cbShortRangeGraph(t,[[1,1],[0,-1],[-1,1]]),
					value: 0.5,
					abbrev: 'D',
					fenAbbrev: "D'",
					initial: [{s:-1,p:164},{s:-1,p:171}],
				},

				15: {
					name: 'iron-w',
					aspect: 'sh-iron',
					graph: this.cbShortRangeGraph(t,[[0,1],[-1,1],[1,1]]),
					value: 0.6,
					abbrev: 'I',
					initial: [{s:1,p:3},{s:1,p:12}],
				},

				16: {
					name: 'iron-b',
					aspect: 'sh-iron',
					graph: this.cbShortRangeGraph(t,[[0,-1],[-1,-1],[1,-1]]),
					value: 0.6,
					abbrev: 'I',
					initial: [{s:-1,p:243},{s:-1,p:252}],
				},

				17: {
					name: 'chariot-soldier',
					aspect: 'sh-chariot',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1],[0,-1],[1,1],[-1,1],[1,-1],[-1,-1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2)
						),
					value: 8,
					abbrev: 'CS',
					fenAbbrev: 'C!',
					initial: [{s:1,p:18},{s:1,p:19},{s:1,p:28},{s:1,p:29},{s:-1,p:226},{s:-1,p:227},{s:-1,p:236},{s:-1,p:237}],
				},

				18: {
					name: 'water-buffalo',
					aspect: 'sh-buffalo',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
						this.cbLongRangeGraph(t, [[0,1],[0,-1]], null, undefined, 2)
						),
					value: 12,
					abbrev: 'WB',
					fenAbbrev: 'W!',
					initial: [{s:1,p:37},{s:1,p:42},{s:-1,p:213},{s:-1,p:218}],
				},

				19: {
					name: 'bishop-general',
					aspect: 'sh-bishop-general',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x90000),
					value: 10,
					rank: 1,
					abbrev: 'BG',
					fenAbbrev: 'B!',
					initial: [{s:1,p:53},{s:1,p:58},{s:-1,p:197},{s:-1,p:202}],
				},

				20: {
					name: 'rook-general',
					aspect: 'sh-rook-general',
					graph: this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1]], null, 0x90000),
					value: 13,
					rank: 1,
					abbrev: 'RG',
					fenAbbrev: 'R!',
					initial: [{s:1,p:54},{s:1,p:57},{s:-1,p:198},{s:-1,p:201}],
				},

				21: {
					name: 'queen',
					aspect: 'sh-queen',
					graph: this.cbQueenGraph(t),
					value: 9.5,
					abbrev: 'FK',
					fenAbbrev: 'Q',
					initial: [{s:1,p:24},{s:-1,p:231}],
				},
				
				22: {
					name: 'lion',
					aspect: 'sh-lion',
					graph: this.cbMergeGraphs(t,
						this.cbKingGraph(t),
						this.cbKnightGraph(t),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x1000000),
						this.cbShortRangeGraph(t,
							[[2,0],[0,2],[-2,0],[0,-2], [2,2],[2,-2],[-2,2],[-2,-2]])
						),
					value: 7,
					abbrev: 'LN',
					fenAbbrev: 'L!',
					initial: [{s:1,p:23},{s:-1,p:232}],
				},

				24: {
					name: 'copper-w',
					aspect: 'sh-copper',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[-1,1],[1,1]]),
					value: 0.8,
					abbrev: 'C',
					initial: [{s:1,p:4},{s:1,p:11}],
				},


				25: {
					name: 'copper-b',
					aspect: 'sh-copper',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[-1,-1],[1,-1]]),
					value: 1,
					abbrev: 'C',
					initial: [{s:-1,p:244},{s:-1,p:251}],
				},

				26: {
					name: 'silver-w',
					aspect: 'sh-silver',
					graph: this.cbShortRangeGraph(t,[[0,1],[1,1],[1,-1],[-1,1],[-1,-1]]),
					value: 0.9,
					abbrev: 'S',
					initial: [{s:1,p:5},{s:1,p:10}],
				},


				27: {
					name: 'silver-b',
					aspect: 'sh-silver',
					graph: this.cbShortRangeGraph(t,[[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]]),
					value: 0.9,
					abbrev: 'S',
					initial: [{s:-1,p:245},{s:-1,p:250}],
				},

				28: {
					name: 'gold-w',
					aspect: 'sh-gold',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[1,0],[-1,0],[1,1],[-1,1]]),
					value: 1,
					abbrev: 'G',
					initial: [{s:1,p:6},{s:1,p:9}],
				},


				29: {
					name: 'gold-b',
					aspect: 'sh-gold',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[1,0],[-1,0],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'G',
					initial: [{s:-1,p:246},{s:-1,p:249}],
				},

				30: {
					name: 'tiger-w',
					aspect: 'sh-tiger',
					graph: this.cbShortRangeGraph(t,[[0,-1],[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'BT',
					fenAbbrev: 'T',
					initial: [{s:1,p:21},{s:1,p:26}],
				},


				31: {
					name: 'tiger-b',
					aspect: 'sh-tiger',
					graph: this.cbShortRangeGraph(t,[[0,1],[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'BT',
					fenAbbrev: 'T',
					initial: [{s:-1,p:229},{s:-1,p:234}],
				},


				32: {
					name: 'elephant-w',
					aspect: 'sh-elephant',
					graph: this.cbShortRangeGraph(t,[[0,1],[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'DE',
					fenAbbrev: 'E',
					initial: [{s:1,p:8}],
				},


				33: {
					name: 'elephant-b',
					aspect: 'sh-elephant',
					graph: this.cbShortRangeGraph(t,[[0,-1],[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 1,
					abbrev: 'DE',
					fenAbbrev: 'E',
					initial: [{s:-1,p:247}],
				},

				34: {
					name: 'falcon-w',
					aspect: 'sh-falcon',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[0,1],[0,2]]),
						this.cbShortRangeGraph(t, [[0,1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[0,2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]])
						),
					value: 8.5,
					abbrev: 'HF',
					fenAbbrev: 'F!',
					initial: [{s:1,p:51},{s:1,p:60}],
				},

				35: {
					name: 'falcon-b',
					aspect: 'sh-falcon',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[0,-1],[0,-2]]),
						this.cbShortRangeGraph(t, [[0,-1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[0,-2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[1,1],[1,-1],[-1,1],[-1,-1]])
						),
					value: 8.5,
					abbrev: 'HF',
					fenAbbrev: 'F!',
					initial: [{s:-1,p:195},{s:-1,p:204}],
				},

				36: {
					name: 'eagle-w',
					aspect: 'sh-eagle',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[1,1],[-1,1],[2,2],[-2,2]]),
						this.cbShortRangeGraph(t, [[1,1],[-1,1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[2,2],[-2,2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1],[1,-1],[-1,-1]])
						),
					value: 9,
					abbrev: 'SE',
					fenAbbrev: 'S!',
					initial: [{s:1,p:52},{s:1,p:59}],
				},

				37: {
					name: 'eagle-b',
					aspect: 'sh-eagle',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[1,-1],[-1,-1],[2,-2],[-2,-2]]),
						this.cbShortRangeGraph(t, [[1,-1],[-1,-1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[2,-2],[-2,-2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1],[1,1],[-1,1]])
						),
					value: 9,
					abbrev: 'SE',
					fenAbbrev: 'S!',
					initial: [{s:-1,p:196},{s:-1,p:203}],
				},

				38: {
					name: 'side-soldier-w',
					aspect: 'sh-side',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbLongRangeGraph(t, [[0,1]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,-1]])
						),
					value: 4,
					abbrev: 'HS',
					fenAbbrev: "S'",
					initial: [{s:1,p:32},{s:1,p:47}],
				},

				39: {
					name: 'side-soldier-b',
					aspect: 'sh-side',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbLongRangeGraph(t, [[0,-1]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,1]])
						),
					value: 4,
					abbrev: 'HS',
					fenAbbrev: "S'",
					initial: [{s:-1,p:208},{s:-1,p:223}],
				},

				40: {
					name: 'vertical-soldier-w',
					aspect: 'sh-vertical',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,-1]])
						),
					value: 4,
					abbrev: 'VS',
					fenAbbrev: "V'",
					initial: [{s:1,p:33},{s:1,p:46}],
				},

				41: {
					name: 'vertical-soldier-b',
					aspect: 'sh-vertical',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,-1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,1]])
						),
					value: 4,
					abbrev: 'VS',
					fenAbbrev: "V'",
					initial: [{s:-1,p:209},{s:-1,p:222}],
				},

				42: {
					name: 'reverse-chariot',
					aspect: 'sh-reverse',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1]]),
					value: 1,
					abbrev: 'RV',
					fenAbbrev: 'A',
					initial: [{s:1,p:16},{s:1,p:31},{s:-1,p:224},{s:-1,p:239}],
				},

				43: {
					name: 'dragon-horse',
					aspect: 'sh-horse',
					graph: this.cbMergeGraphs(t,
						this.cbBishopGraph(t),
						this.cbShortRangeGraph(t, [[1,0],[0,1],[0,-1],[-1,0]])
						),
					value: 5.5,
					abbrev: 'DH',
					fenAbbrev: 'H',
					initial: [{s:1,p:35},{s:1,p:44},{s:-1,p:211},{s:-1,p:220}],
				},
				
				44: {
					name: 'dragon-king',
					aspect: 'sh-dragon',
					graph: this.cbMergeGraphs(t,
						this.cbRookGraph(t),
						this.cbShortRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]])
						),
					value: 7,
					abbrev: 'DK',
					fenAbbrev: 'D',
					initial: [{s:1,p:36},{s:1,p:43},{s:-1,p:212},{s:-1,p:219}],
				},

				45: {
					name: 'free-eagle',
					aspect: 'sh-free',
					graph: this.cbMergeGraphs(t,
						this.cbQueenGraph(t),
						this.cbShortRangeGraph(t,
							[[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x2000000),
						this.cbShortRangeGraph(t,
							[[2,0],[0,2],[-2,0],[0,-2],[2,2],[2,-2],[-2,2],[-2,-2]])
						),
					value: 10,
					abbrev: 'FE',
					fenAbbrev: 'E!',
					initial: [{s:1,p:40},{s:-1,p:215}],
				},
				
				46: {
					name: 'lion-hawk',
					aspect: 'sh-hawk',
					graph: this.cbMergeGraphs(t,
						this.cbBishopGraph(t),
						this.cbKnightGraph(t),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x1000000),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[2,0],[0,2],[-2,0],[0,-2], [2,2],[2,-2],[-2,2],[-2,-2]])
						),
					value: 8.5,
					abbrev: 'LH',
					fenAbbrev: 'H!',
					initial: [{s:1,p:39},{s:-1,p:216}],
				},

				47: {
					name: 'vice-general',
					aspect: 'sh-vice',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x90030),
					value: 13,
					rank: 2,
					area: 1,
					abbrev: 'VG',
					fenAbbrev: 'V!',
					initial: [{s:1,p:56},{s:-1,p:199}],
				},
				
				48: {
					name: 'great-general',
					aspect: 'sh-great',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1],[1,0],[-1,0],[0,1],[0,-1]], null, 0x90000),
					value: 18,
					rank: 3,
					abbrev: 'GG',
					fenAbbrev: 'G!',
					initial: [{s:1,p:55},{s:-1,p:200}],
				},
				
				49: {
					name: 'fire-demon',
					aspect: 'sh-demon',
					graph: this.cbLongRangeGraph(t, [[0,1],[0,-1],[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x30030),
					value: 60,
					area: 2,
					abbrev: 'FD',
					fenAbbrev: 'D!',
					initial: [{s:1,p:38},{s:1,p:41},{s:-1,p:214},{s:-1,p:217}],
				},
				
				50: {
					name: 'king',
					aspect: 'sh-king',
					isKing: true,
					graph: this.cbKingGraph(t),
					abbrev: 'K',
					initial: [{s:1,p:7},{s:-1,p:248}],
				},

				51: {
					name: 'tokin-w',
					aspect: 'sh-tokin',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[1,0],[-1,0],[1,1],[-1,1]]),
					value: 0.8,
					abbrev: '+P',
				},

				52: {
					name: 'tokin-b',
					aspect: 'sh-tokin',
					graph: this.cbShortRangeGraph(t,[[0,1],[0,-1],[1,0],[-1,0],[1,-1],[-1,-1]]),
					value: 0.8,
					abbrev: '+P',
				},

				53: {
					name: 'white-horse-w',
					aspect: 'sh-red-white',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1],[1,1],[-1,1]]),
					value: 5,
					abbrev: '+L',
				},

				54: {
					name: 'white-horse-b',
					aspect: 'sh-red-white',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1],[1,-1],[-1,-1]]),
					value: 5,
					abbrev: '+L',
				},

				55: {
					name: 'bishop2',
					aspect: 'sh-red-bishop',
					graph: this.cbBishopGraph(t),
					value: 3,
					abbrev: '+FL',
					fenAbbrev: '+F',
				},

				56: {
					name: 'free-boar',
					aspect: 'sh-red-boar',
					graph: this.cbLongRangeGraph(t,[[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 7,
					abbrev: '+SM',
					fenAbbrev: '+M',
				},

				57: {
					name: 'flying-ox',
					aspect: 'sh-red-ox',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1],[1,1],[-1,1],[1,-1],[-1,-1]]),
					value: 7.5,
					abbrev: '+VM',
					fenAbbrev: '+V',
				},

				58: {
					name: 'dragon-horse2',
					aspect: 'sh-red-horse',
					graph: this.cbMergeGraphs(t,
						this.cbBishopGraph(t),
						this.cbShortRangeGraph(t, [[1,0],[0,1],[0,-1],[-1,0]])
						),
					value: 5,
					abbrev: '+B',
				},
				
				59: {
					name: 'dragon-king2',
					aspect: 'sh-red-dragon',
					graph: this.cbMergeGraphs(t,
						this.cbRookGraph(t),
						this.cbShortRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]])
						),
					value: 6.5,
					abbrev: '+R',
				},

				60: {
					name: 'queen2',
					aspect: 'sh-red-queen',
					graph: this.cbQueenGraph(t),
					value: 9,
					abbrev: '+PH',
					fenAbbrev: '+X',
				},
				
				61: {
					name: 'lion2',
					aspect: 'sh-red-lion',
					graph: this.cbMergeGraphs(t,
						this.cbKingGraph(t),
						this.cbKnightGraph(t),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x1000000),
						this.cbShortRangeGraph(t,
							[[2,0],[0,2],[-2,0],[0,-2], [2,2],[2,-2],[-2,2],[-2,-2]])
						),
					value: 6.5,
					abbrev: '+KN',
					fenAbbrev: '+O',
				},

				62: {
					name: 'side-soldier2-w',
					aspect: 'sh-red-side',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbLongRangeGraph(t, [[0,1]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,-1]])
						),
					value: 3,
					abbrev: '+N',
					fenAbbrev: '+N',
				},

				63: {
					name: 'side-soldier2-b',
					aspect: 'sh-red-side',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbLongRangeGraph(t, [[0,-1]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,1]])
						),
					value: 3,
					abbrev: '+N',
					fenAbbrev: '+N',
				},

				64: {
					name: 'multi-general-w',
					aspect: 'sh-red-multi',
					graph: this.cbLongRangeGraph(t,[[0,1],[1,-1],[-1,-1]]),
					value: 3,
					abbrev: '+D',
					fenAbbrev: "+D'",
				},

				65: {
					name: 'multi-general-b',
					aspect: 'sh-red-multi',
					graph: this.cbLongRangeGraph(t,[[1,1],[0,-1],[-1,1]]),
					value: 3,
					abbrev: '+D',
					fenAbbrev: "+D'",
				},

				66: {
					name: 'vertical-soldier2-w',
					aspect: 'sh-red-vertical',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,-1]])
						),
					value: 3,
					abbrev: '+I',
					fenAbbrev: '+I',
				},

				67: {
					name: 'vertical-soldier2-b',
					aspect: 'sh-red-vertical',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,-1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2),
						this.cbShortRangeGraph(t, [[0,1]])
						),
					value: 3,
					abbrev: '+I',
					fenAbbrev: '+I',
				},

				68: {
					name: 'tertarch',
					aspect: 'sh-red-tetrarch',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,-1],[0,1],[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x30001),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, 0x30001, 3),
						this.cbShortRangeGraph(t, [[0,1],[0,-1],[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x400000)
						),
					value: 9.5,
					abbrev: '+CS',
					fenAbbrev: '+C!',
				},


				69: {
					name: 'fire-demon2',
					aspect: 'sh-red-demon',
					graph: this.cbLongRangeGraph(t, [[0,1],[0,-1],[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x30030),
					value: 60,
					area: 2,
					abbrev: '+WB',
					fenAbbrev: '+W!',
				},

				70: {
					name: 'vice-general2',
					aspect: 'sh-red-vice',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x90030),
					value: 9.5,
					rank: 15,
					area: 1,
					abbrev: '+BG',
					fenAbbrev: '+B!',
				},
				
				71: {
					name: 'great-general2',
					aspect: 'sh-red-great',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1],[1,0],[-1,0],[0,1],[0,-1]], null, 0x90000),
					value: 18,
					rank: 3,
					abbrev: '+RG',
					fenAbbrev: '+R!',
				},
				
				72: {
					name: 'free-eagle2',
					aspect: 'sh-red-free',
					graph: this.cbMergeGraphs(t,
						this.cbQueenGraph(t),
						this.cbShortRangeGraph(t,
							[[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x2000000),
						this.cbShortRangeGraph(t,
							[[2,0],[0,2],[-2,0],[0,-2],[2,2],[2,-2],[-2,2],[-2,-2]])
						),
					graph: this.cbQueenGraph(t),
					value: 10,
					abbrev: '+FK',
					fenAbbrev: '+Q',
				},
				
				73: {
					name: 'lion-hawk2',
					aspect: 'sh-red-hawk',
					graph: this.cbMergeGraphs(t,
						this.cbBishopGraph(t),
						this.cbKnightGraph(t),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]], null, 0x1000000),
						this.cbShortRangeGraph(t,
							[[1,0],[0,1],[-1,0],[0,-1],[2,0],[0,2],[-2,0],[0,-2], [2,2],[2,-2],[-2,2],[-2,-2]])
						),
					value: 8.5,
					abbrev: '+LN',
					fenAbbrev: '+L!',
				},

				74: {
					name: 'side-mover2',
					aspect: 'sh-red-sweeper',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0]]),
						this.cbShortRangeGraph(t, [[0,1],[0,-1]])
						),
					value: 2.5,
					abbrev: '+C',
				},

				75: {
					name: 'vertical-mover2',
					aspect: 'sh-red-climber',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1],[0,-1]]),
						this.cbShortRangeGraph(t, [[1,0],[-1,0]])
						),
					value: 2.5,
					abbrev: '+S',
				},

				76: {
					name: 'rook2',
					aspect: 'sh-red-rook',
					graph: this.cbRookGraph(t),
					value: 4.5,
					abbrev: '+G',
				},

				77: {
					name: 'flying-stag',
					aspect: 'sh-red-stag',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1],[0,-1]]),
						this.cbShortRangeGraph(t, [[1,0],[-1,0],[1,1],[1,-1],[-1,1],[-1,-1]])
						),
					value: 4,
					abbrev: '+BT',
					fenAbbrev: '+T',
				},

				78: {
					name: 'crown-prince',
					aspect: 'sh-red-prince',
//					isKing: true,
					graph: this.cbKingGraph(t),
					abbrev: '+DE',
					fenAbbrev: '+E',
				},

				79: {
					name: 'bishop-general2',
					aspect: 'sh-red-bishop-general',
					graph: this.cbLongRangeGraph(t, [[1,1],[-1,1],[1,-1],[-1,-1]], null, 0x90000),
					value: 8,
					rank: 1,
					abbrev: '+HF',
					fenAbbrev: '+H!',
				},

				80: {
					name: 'rook-general2',
					aspect: 'sh-red-rook-general',
					graph: this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1]], null, 0x90000),
					value: 9,
					rank: 1,
					abbrev: '+SE',
					fenAbbrev: '+S!',
				},

				81: {
					name: 'water-buffalo2',
					aspect: 'sh-red-buffalo',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[1,1],[-1,1],[1,-1],[-1,-1]]),
						this.cbLongRangeGraph(t, [[0,1],[0,-1]], null, undefined, 2)
						),
					value: 7,
					abbrev: '+SS',
					fenAbbrev: "+S'",
				},

				82: {
					name: 'chariot-soldier2',
					aspect: 'sh-red-chariot',
					graph: this.cbMergeGraphs(t,
						this.cbLongRangeGraph(t, [[0,1],[0,-1],[1,1],[-1,1],[1,-1],[-1,-1]]),
						this.cbLongRangeGraph(t, [[1,0],[-1,0]], null, undefined, 2)
						),
					value: 7,
					abbrev: '+VS',
					fenAbbrev: "+V'",
				},

				83: {
					name: 'whale-w',
					aspect: 'sh-red-whale',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1],[1,-1],[-1,-1]]),
					value: 4,
					abbrev: '+RV',
					fenAbbrev: '+A',
				},

				84: {
					name: 'whale-b',
					aspect: 'sh-red-whale',
					graph: this.cbLongRangeGraph(t,[[0,1],[0,-1],[1,1],[-1,1]]),
					value: 4,
					abbrev: '+RV',
					fenAbbrev: '+A',
				},

				85: {
					name: 'falcon-w',
					aspect: 'sh-red-falcon',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[0,1],[0,2]]),
						this.cbShortRangeGraph(t, [[0,1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[0,2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,-1],[1,1],[1,-1],[-1,1],[-1,-1]])
						),
					value: 8,
					abbrev: '+DH',
					fenAbbrev: '+H',
				},

				86: {
					name: 'falcon-b',
					aspect: 'sh-red-falcon',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[0,-1],[0,-2]]),
						this.cbShortRangeGraph(t, [[0,-1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[0,-2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[1,1],[1,-1],[-1,1],[-1,-1]])
						),
					value: 8,
					abbrev: '+DH',
					fenAbbrev: '+H',
				},

				87: {
					name: 'eagle-w',
					aspect: 'sh-red-eagle',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[1,1],[-1,1],[2,2],[-2,2]]),
						this.cbShortRangeGraph(t, [[1,1],[-1,1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[2,2],[-2,2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1],[1,-1],[-1,-1]])
						),
					value: 8.5,
					abbrev: '+DK',
					fenAbbrev: '+D',
				},

				88: {
					name: 'eagle-b',
					aspect: 'sh-red-eagle',
					graph: this.cbMergeGraphs(t,
						this.cbShortRangeGraph(t, [[1,-1],[-1,-1],[2,-2],[-2,-2]]),
						this.cbShortRangeGraph(t, [[1,-1],[-1,-1]], null, 0x400000),
						this.cbShortRangeGraph(t, [[2,-2],[-2,-2]], null, 0x800000),
						this.cbLongRangeGraph(t, [[1,0],[-1,0],[0,1],[0,-1],[1,1],[-1,1]])
						),
					value: 8.5,
					abbrev: '+DK',
					fenAbbrev: '+D',
				},

				89: {
					name: 'cat-sword',
					aspect: 'sh-shuttle',
					graph: this.cbShortRangeGraph(t, [[1,-1],[-1,-1],[1,1],[-1,1]]),
					value: 1,
					abbrev: '+DK',
					fenAbbrev: '+D',
				},

			},

			promote: function(aGame,piece,move) {
				if(piece.t>44) // unpromotable or already promoted
					return [];
				var rank=t.R(move.f);
				if(piece.s==1) {
					if(rank>=11) return []; // was already in zone
					if(t.R(move.t) < 11) return []; // did not end in zone
				} else {
					if(rank<=4) return [];
					if(t.R(move.t)>4) return [];
				}
				if(piece.t<24) // P,L,N,D,I: map pair on pair; FL,SM,VM,B,R,Ph,Kn,CS,WB,BG,RG,Ln,Q: single on single
					return [piece.t, piece.t+51];
				if(piece.t>41) // RV, DH, DK: choose correctly oriented promoted type
					return [piece.t, 2*piece.t+(piece.s==1 ? -1 : 0)];
				return [piece.t, (piece.t>>1)+62]; // map pair on single
			},

evaluate:function(e,r,i,demons,generals){

 var $this = this;

 function Type(s){
  var i=$this.board[s];
  if(i<0) return -1;
  var p = $this.pieces[i];
  return p.t;
 }

 var a=i[1].count,n=i[-1].count;
 if(!a[50]&&!a[78])this.mFinished=!0,this.mWinner=-1;
 if(!n[50]&&!n[78])this.mFinished=!0,this.mWinner=1;
 this.noCaptCount>=100&&(this.mFinished=!0,this.mWinner=JocGame.DRAW);
 var score = 0;

 var k1=0, k2=0;
 var k = this.kings[1];
 if(k == 7 || k == 23) {
   if(this.board[6] >= 0 && this.board[8] >= 0) {
     if(this.board[22] >= 0 && this.board[24] >= 0 &&
        (k == 7 || this.board[38] >= 0 && this.board[40] >= 0)) k1 = 1; // vertical mate possible
     if(k == 7 && this.board[23] >= 0 && this.board[24] >= 0) k1 |= 2;  // diagonal mate possible
   }
 }
 k = this.kings[-1];
 if(k == 248 || k == 232) {
   if(this.board[247] >= 0 && this.board[249] >= 0) {
     if(this.board[231] >= 0 && this.board[233] >= 0 &&
        (k == 248 || this.board[215] >= 0 && this.board[217] >= 0)) k2 = 1; // vertical mate possible
     if(k == 248 && this.board[231] >= 0 && this.board[232] >= 0) k2 |= 2;  // diagonal mate possible
   }
 }

 // deal with VG mate threat
 if(Type(73)<0 && k2&2){
  score += 10;
  if(Type(173)!=37 && Type(175)!=37 && Type(143)!=37 &&
     Type(188)==1 && this.pieces[generals[1][1]].p >= 0) score += 100;
 }
 if(Type(182)<0 && k1&2){
   score -= 15;
   if(Type(82)!=36 && Type(80)!=36 && Type(112)!=36 &&
      Type(67)==0 && this.pieces[generals[-1][1]].p >= 0) score -= 50;
 }

 var wd=0, bd=0;
 for(var j=demons.length-1; j>=0; j--){
  var p = this.pieces[demons[j]];
  if(p.p >= 0 && p.t == 49) { // penalty for undeveloped Demons
    if(p.s < 0) {
      bd++;
      if(p.p >= 176) {
        score += 30;
        if(this.board[p.p-15]>=0 && this.board[p.p-16]>=0 && this.board[p.p-17]>=0) score += 5;
      }
    } else {
      wd++;
      if(p.p < 80) {
        score -= 30;
        if(this.board[p.p+15]>=0 && this.board[p.p+16]>=0 && this.board[p.p+17]>=0) score -= 5;
      }
    }
  }
 }

 // GG balance
 var g1, g2;
 if((g1 = this.pieces[generals[1][0]].p) < 0) {
  if((g2 = this.pieces[generals[-1][0]].p) >= 0) { // gote has GG, sente not
   var r1 = this.pieces[generals[1][2]].p, r2 = this.pieces[generals[1][3]].p; // sente RG locations
   score -= wd*wd*50;
   if(k1 & 1) {
     if(r1 < 0 && r2 < 0) score -= 300;
     else {
       if((g2 ^ r1) & ~0xF0 && (g2 ^ r2) & ~0xF0 || (g2 ^ this.kings[-1]) & 15) { // GG not pinned to his King
         if(r1 - 7 & ~0xF && r2 - 7 & ~0xF0) // no RG in front of his King
           score -= (r1 < 0 || r2 < 0 ? 200 : 100);
       }
     }
   }
  }
 } else {
  if(this.pieces[generals[-1][0]].p < 0) {  // sente has GG, gote not
   var r1 = this.pieces[generals[-1][2]].p, r2 = this.pieces[generals[-1][3]].p; // gote RG locations
   score += bd*bd*50;
   if(k2 & 1) {
     if(r1 < 0 && r2 < 0) score += 300;
     else {
       if((g1 ^ r1) & ~0xF0 && (g1 ^ r2) & ~0xF0 || (g1 ^ this.kings[1]) & 15) { // GG not pinned to his King
         if(248 - r1 & 15 && 248 - r2 & 15) // no RG in front of his King
           score += (r1 < 0 || r2 < 0 ? 200 : 100);
       }
     }
   }
  }
 }

 // unprotected burn spots
 if(wd) {
  if(Type(178)==1 && this.board[210]>=0) score += 5;
  else if(Type(178)==49 && this.board[211] >= 0) score += 20;
  if(Type(189)==1 && this.board[221]>=0) score += 5;
  else if(Type(189)==49 && this.board[220] >= 0) score += 20;
 }
 if(bd) {
  if(Type(66)==0 && this.board[34]>=0) score -= 5;
  else if(Type(66)==49 && this.board[35]>=0) score -= 20;
  if(Type(77)==0 && this.board[45]>=0) score -= 5;
  else if(Type(77)==49 && this.board[44]>=0) score -= 20;
 }

 r.posValue += score;
// if(this.zSign == -1520833313) r.pieceValue += 100; // Baby metal GG x FD: won for sente
}
}}

	var OriginalApplyMove = Model.Board.ApplyMove;
	Model.Board.ApplyMove = function(aGame,move) {
		if((move.a == 'FD' || move.a == '+WB') && !move.burn) {
			var graph = aGame.g.pTypes[50].graph[move.t];
			var nrOfMoves = graph.length;
			for(var i=0; i<nrOfMoves; i++) {
				var to = graph[i][0] & 0xffff; // & MASK;
				var victim = this.board[to];
				if(victim >= 0 && this.pieces[victim].s != this.mWho) {
					var piece1=this.pieces[victim];
					this.zSign=aGame.zobrist.update(this.zSign,"board",piece1.i,piece1.p);
					this.board[to] = -1;
					piece1.p = -1;
				}
			}
		}
		if(move.via !== undefined) { // locust capture, remove victim
			var piece1=this.pieces[move.kill];
			this.zSign=aGame.zobrist.update(this.zSign,"board",piece1.i,piece1.p);
			this.board[piece1.p]=-1;
			piece1.p=-1;
			piece1.m=true;
			this.noCaptCount=0;
		}
		OriginalApplyMove.apply(this, arguments);
		if(move.burn) {
			var victim = this.pieces[this.board[move.t]];
			this.zSign=aGame.zobrist.update(this.zSign,"board",victim.i,victim.p);
			this.board[move.t] = -1;
                        victim.p = -1;
		}
//console.log('key = ' + this.zSign);
	}

	var OriginalQuickApply = Model.Board.cbQuickApply;
	Model.Board.cbQuickApply = function(aGame,move) {
		var tmp = OriginalQuickApply.apply(this, arguments);
		if(move.burn) {
			this.pieces[this.board[move.t]].p = -1;
			this.board[move.t] = -1;
		} else if(move.a == 'FD' || move.a == '+WB') {
			var graph = aGame.g.pTypes[50].graph[move.t];
			var nrOfMoves = graph.length;
			for(var i=0; i<nrOfMoves; i++) {
				var to = graph[i][0] & 0xffff; // & MASK;
				var victim = this.board[to];
				if(victim >= 0 && this.pieces[victim].s != this.mWho) {
					this.board[to] = -1;
					this.pieces[victim].p = -1;
					tmp.unshift({
						i: victim,
						f: -1,
						t: to,
					});
				}
			}
		}
		if(move.via !== undefined) { // remove locust victim
			this.board[move.via] = -1;
			this.pieces[move.kill].p = -1;
			tmp.unshift({
				i: move.kill,
				f: -1,
				t: move.via,
			});
		}
		return tmp;
	}

	var OriginalMoveGen = Model.Board.cbGeneratePseudoLegalMoves;
	Model.Board.cbGeneratePseudoLegalMoves = function(aGame) {
		this.specials = [];
		var moves = OriginalMoveGen.apply(this, arguments);
		for(var k=0; k<this.specials.length; k++) {
			var m = this.specials[k];
			if(m.flag == 1) moves.push({f:m.f, t:m.f, c:null, a:m.a, via:m.t, kill:m.c});
			else if(m.flag==2) {
				var v = m.f + m.t >> 1, vv = this.board[v];
				if(vv >= 0 && this.pieces[vv].s != this.mWho) {
					moves.push({f:m.f, t:m.t, c:m.c, a:m.a, via:v, kill: vv});
				}
			} else if(m.flag & 12) {
				var graph2 = aGame.g.pTypes[m.flag&4?50:89].graph[m.t]; // King graph at locust square
				var n = graph2.length;
				for(var j=0; j<n; j++) {
					var to2 = graph2[j][0] & 0xffff; // & MASK;
					var victim2 = (to2 == m.f ? -1 : this.board[to2]); // no self-capt on igui!
					if(victim2 < 0 || this.pieces[victim2].s != this.mWho)
						moves.push({
							f: m.f,
							t: to2,
							c: victim2 < 0 ? null : victim2,
							a: m.a,
							via: m.t,
							kill: m.c
						});
				}
			}
		}
		return moves;
	}

	var OriginalGetAttackers = Model.Board.cbGetAttackers;
	Model.Board.cbGetAttackers = function(aGame,pos,who,isKing) {
		return OriginalGetAttackers.apply(this, arguments);
	}

	var OriginalToString = Model.Move.ToString;
	Model.Move.ToString = function(format) {
		if(this.via !== undefined) { // locust capture	(computer form currently undefined)		
			return this.a + 'x' + t.PosName(this.via) +
					(this.c == null ? '-' : 'x') + t.PosName(this.t);
		}
		return OriginalToString.call(this, format);
	}

	Model.Board.StaticGenerateMoves=function(e){
		return this.PickMoveFromDatabase(e,this.MoveDatabase)
	},

	Model.Board.MoveDatabase={
		"-1#-371803318": [{m:"SEl13-n11",e:10000}],
		"1#585901167": [{m:"BGk4-i6",e:10000}],
		"-1#-1169926593": [{m:"SEn11-p11",e:10000}, {m:"SEn11-p9",e:10000}],
		"1#513774179": [{m:"BGi6-n11",e:10000}, {m:"FDj3-k6",e:10000}],
		"-1#1399730176": [{m:"SEp9xn11",e:10000}],
		"-1#426015977": [{m:"SEp11xn11",e:10000}],
		"1#1608895034": [{m:"FDj3-i6",e:10000}],
		"-1#-1179269951": [{m:"g12-g11",e:10000}],
		"1#-1604183980": [{m:"FDi6xi12",e:10000}],
		"-1#14040784": [{m:"FDj14xi12",e:10000}],
		"1#-2064578320": [{m:"VGi4-i6",e:10000}],
		"-1#236676048": [{m:"FDi12-e8",e:10000}],
		"1#-896998066": [{m:"RGg4xg13",e:10000}],
		"-1#-1376989302": [{m:"BGf13-g12",e:10000}],
		"1#-969644818": [{m:"b5-b6",e:10000}],
		"-1#175863910": [{m:"FDg14-i11",e:10000}],
		"1#-2040390026": [{m:"g5-g6",e:10000}],
		"-1#1571953500": [{m:"FDe8-e9",e:10000}],
		"1#-1710639262": [{m:"h5-h6",e:10000}],
		"-1#-741605879": [{m:"FDe9-h7",e:10000}],
		"1#-1520833313": [{m:"VGi4-i6",e:10000}],
		"1#-1600245074": [{m:"GGh4xj4",e:10000}],
		"1#1196753013": [{m:"GGh4xj4",e:10000}],
		"1#-1489267220": [{m:"VGi6xn11",e:10000}],
		"1#1316237890": [{m:"VGi6xn11",e:10000}],
		"1#-922339216": [{m:"i5xi6",e:10000}],
		"1#2141343161": [{m:"GGh4xj4",e:10000}],
		"1#1933011248": [{m:"GGh4xj4",e:10000}],
		"1#-1822819159": [{m:"VGi4xp11",e:10000}],
		"1#2048285447": [{m:"VGi4xp11",e:10000}],
		"1#1323819257": [{m:"VGi4xp11",e:10000}],
		"1#2119480231": [{m:"GGj4-i4",e:10000}],
		"1#-1759833079": [{m:"GGj4-i4",e:10000}],
		"1#-1544900617": [{m:"GGh4-i4",e:10000}],
		"1#1750004106": [{m:"GGi4-o10",e:10000}],
		"1#-2130618844": [{m:"GGi4-o10",e:10000}],
		"1#1558351211": [{m:"GGi4-o10",e:10000}],
		"1#-1429705851": [{m:"GGh4-i4",e:10000}],
		"1#2004252629": [{m:"GGj4-i4",e:10000}],
		"1#-1834158862": [{m:"GGj4-i4",e:10000}],
		"1#-1773970315": [{m:"GGj4-i4",e:10000}],
		"1#-1428089864": [{m:"GGj4-i4",e:10000}],
		"-1#1939464018": [{m:"GGj4-i4",e:10000}],
		"-1#-1757616305": [{m:"GGi13xi6",e:10000}],
		"-1#-1911090912": [{m:"KNj15-l5",e:10000}],
		"-1#1811007642": [{m:"FDj14-m12",e:10000}],
		"-1#-701846326": [{m:"KNj15-l15",e:10000}],
		"1#375632775": [{m:"Bgi6xn11",e:10000}],
		"-1#1125284659": [{m:"WBk14xn11",e:10000}],
		"1#1902963124": [{m:"FDj3-k4",e:10000}],
		"-1#-686343730": [{m:"g12-g11",e:10000}],
		"1#-826219173": [{m:"FDk6xc12",e:10000}],
		"-1#1458664723": [{m:"DHd4-a11",e:10000}],
		"1#900133940": [{m:"FDc12-f9",e:10000}],
		"-1#1329845028": [{m:"VGh13-b7",e:10000}],
		"-1#-965443024": [{m:"Bc14-b15",e:10000}],
		"-1#-763440915": [{m:"Bc14-b15",e:10000}],
		"1#-1112547009": [{m:"FDf9-c6",e:10000}],
		"-1#-1694815645": [{m:"FDg14-f11",e:10000}, {m:"FDg14-h11",e:10000}],
		"-1#2021152413": [{m:"DHd14-a11",e:10000}],
		"-1#1640689834": [{m:"VGh13-c8",e:10000}],
		"-1#223302189": [{m:"FDg14-f11",e:10000}],
		"-1#-124296703": [{m:"GGi13-h13",e:10000}],
		"-1#311603825": [{m:"VGh13-c8",e:10000}],
		"-1#": [{m:"",e:10000}],
		"-1#": [{m:"",e:10000}],
//		"1#": [{m:"",e:10000}],
		"1#513774179": [{m:"FDj3-i6",e:10000}],
		"-1#1316172031": [{m:"g12-g11",e:10000}],
		"1#1470426218": [{m:"SEe4-c6",e:10000}],
		"-1#897100397": [{m:"BG13f-11h",e:10000}],
		"1#-1541058667": [{m:"SEc6-a6",e:10000}],
		"-1#-848621713": [{m:"FDg14-f11",e:10000}],
		"1#-902519652": [{m:"FDk6-k9",e:10000}],
		"-1#1140307653": [{m:"FDf11-i11",e:10000}],
		"1#-1878816156": [{m:"FDk9xi11",e:10000}],
		"1#1419107978": [{m:"FDj3-k6",e:10000}],
		"-1#75070486": [{m:"g12-g11",e:10000}],
		"1#497983619": [{m:"SEe4-c6",e:10000}],
		"-1#2138236548": [{m:"BG13f-11h",e:10000}],
		"1#-298908804": [{m:"SEc6-a6",e:10000}],
		"-1#-2023668858": [{m:"FDg14-f11",e:10000}],
		"1#-2143360907": [{m:"FDk6-k9",e:10000}],
		"-1#167639596": [{m:"FDf11-i11",e:10000}],
		"1#-636893555": [{m:"FDk9xi11",e:10000}],
//		"-1#-284192613": [{m:"",e:10000}],
		"1#375632775": [{m:"BG16xn11",e:10000}],
		"-1#-686343730": [{m:"g12-g11",e:10000}],
		"-1#1458664723": [{m:"DHd14-a11",e:10000}],
		"-1#-965443024": [{m:"Bc14-b15",e:10000}],
		"-1#1364189879": [{m:"i12-i11",e:10000}],
		"-1#-288709796": [{m:"VGh13-d9",e:10000}],
		"-1#-763440915": [{m:"Bc14-b15",e:10000}],
		"-1#1162195050": [{m:"i12-i11",e:10000}],
		"-1#-88018559": [{m:"VGh13-d9",e:10000}],
//		"1#": [{m:"",e:10000}],
		"1#0": [{m:"",e:10000}]
	}

}();
